//+------------------------------------------------------------------+
//|                                             Figurelli Series.mq4 |
//|                                                Rogerio Figurelli |
//|                                      figurelli@quantafinance.com |
//+------------------------------------------------------------------+
//|                                                    QuantaFinance |
//|                                     http://www.quantafinance.com |
//+------------------------------------------------------------------+
//|                                       Figurelli Series Indicator |
//|                        calculates multiple moving averages trend |
//+------------------------------------------------------------------+
#property copyright "QuantaFinance"
#property link      "http://www.quantafinance.com"

// Version 2009-09-01

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Black

//---- input parameters
extern int series=36; // number of series
extern int interval=6; // interval between series
extern int maxbars=1000;
extern bool   alertsOn           = false;
extern bool   alertsOnCurrent    = false;
extern bool   alertsMessage      = true;
extern bool   alertsSound        = false;
extern bool   alertsEmail        = false;
extern bool   alertsNotification = false;

//---- buffers
double Indicador[];
double Middle[];
double trend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(3);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,Indicador);
   SetIndexBuffer(1,Middle);
   SetIndexBuffer(2,trend);
   return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int i;
   int counted_bars=IndicatorCounted();
   double sma;
   int tot_Ask,tot_Bid,tot;
   
   if (counted_bars<0) return(-1);
   int limit=Bars-counted_bars;
   if (limit>maxbars) limit=maxbars;
   for (int shift=limit; shift>=0; shift--) {
      tot_Ask=0;
      tot_Bid=0;
      for (i=0; i<series; i++) {
         sma=iMA(NULL,0,interval+i*interval,8,MODE_SMA,PRICE_CLOSE,shift);
         if (Close[shift]<sma) tot_Ask++;
         if (Close[shift]>sma) tot_Bid++;
      }
      tot=tot_Bid-tot_Ask;
      Indicador[shift]=tot;
      Middle[shift]=0;
      trend[shift] = trend[shift+1];
         if (Indicador[shift]>0) trend[shift] =  1;
         if (Indicador[shift]<0) trend[shift] = -1;
   }
   manageAlerts();
   return(0);
}
//+------------------------------------------------------------------+

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 

      //
      //
      //
      //
      //
            
      static datetime time1 = 0;
      static string   mess1 = "";
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(time1,mess1,whichBar,"up");
         if (trend[whichBar] == -1) doAlert(time1,mess1,whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

        message = Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" Figurelli serries trend changed to "+doWhat;
          if (alertsMessage)      Alert(message);
          if (alertsEmail)        SendMail(StringConcatenate(Symbol()," Figurelli serries "),message);
          if (alertsNotification) SendNotification(message);
          if (alertsSound)        PlaySound("alert2.wav");
   }
}
